/*
 * ============LICENSE_START========================================================================
 * ONAP : ccsdk feature sdnr wt
 * =================================================================================================
 * Copyright (C) 2019 highstreet technologies GmbH Intellectual Property. All rights reserved.
 * =================================================================================================
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 * ============LICENSE_END==========================================================================
 */
package org.onap.ccsdk.features.sdnr.wt.odlux.bundles.test;

import static org.junit.Assert.*;

import org.junit.Test;
import org.onap.ccsdk.features.sdnr.wt.odlux.OdluxBundleLoaderImpl;
import org.onap.ccsdk.features.sdnr.wt.odlux.bundles.MyOdluxBundle;

public class TestBundleRes {

    @Test
    public void test() {
        OdluxBundleLoaderImpl loader = OdluxBundleLoaderImpl.getInstance();
        MyOdluxBundle b = new MyOdluxBundle();
        b.setLoader(loader);
        b.setIndex(0);
        b.setBundleName("abc");
        b.initialize();
        assertTrue(loader.getNumberOfBundles()==1);
        assertNotNull(b.getLoader());
        assertEquals("abc",b.getBundleName());
        assertTrue(b.hasResource("test.js"));
        assertNotNull(b.getResourceFileContent("test.js"));
        b.clean();
        assertTrue(loader.getNumberOfBundles()==0);
    }

}
